<?php
/*
= LuxCal log in / register / change personal data page =

 Copyright 2009-2016 LuxSoft - www.LuxSoft.eu

This file is part of the LuxCal Web Calendar.

The LuxCal Web Calendar is free software: you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software Foundation, 
either version 3 of the License, or (at your option) any later version.

The LuxCal Web Calendar is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the LuxCal 
Web Calendar. If not, see: http://www.gnu.org/licenses/.
*/


//sanity check
if (empty($lcV)) { exit('not permitted ('.substr(basename(__FILE__),0,-4).')'); }

//initialize
$adminLang = (file_exists("./lang/ai-{$opt['cL']}.php")) ? $opt['cL'] : "english";
require "./lang/ai-{$adminLang}.php";
$msg = '';

$emlStyle = "background:#FFFFDD; color:#000099; font:12px arial, sans-serif;"; //email body style definition
$emlHeader = "
<html>
<head>\n<title>{$set['calendarTitle']} {$ax['cro_mailer']}</title>
<style type='text/css'>
body, p, table {{$emlStyle}}
td {vertical-align:top;}
.bold {font-weight:bold;}
</style>
</head>
<body>
";
$emlTrailer = "
</body>
</html>
";

function notifyReg($uName,$eMail) { //notify a new user registration
	global $ax, $set, $emlStyle, $emlHeader, $emlTrailer;
		
	//compose email message
	$dDate = IDtoDD(date('Y-m-d')); //current date in display format
	$noteText = $ax['log_new_reg'];
	$subject = "{$set['calendarTitle']} - {$noteText}: {$uName}";
	$msgText = $emlHeader."
<p>{$set['calendarTitle']} {$ax['cro_mailer']} {$dDate}</p>
<p>{$noteText}:</p>
<table>
	<tr><td>{$ax['log_un']}:</td><td>{$uName}</td></tr>
	<tr><td>{$ax['log_em']}:</td><td>{$eMail}</td></tr>
	<tr><td>{$ax['log_date_time']}:</td><td>{$dDate} {$ax['at_time']} ".ITtoDT(date("H:i"))."</td></tr>
</table>
<p><a href='{$set['calendarUrl']}'>{$ax['cro_open_calendar']}</a></p>
{$emlTrailer}";
	//send email
	sendMail($subject, $msgText, $set['calendarEmail']);
}

$xCode = isset($_POST["xCode"]) ? $_POST["xCode"] : '';
$lUn_Em = isset($_POST["lUn_Em"]) ? $_POST["lUn_Em"] : '';
$lUname = isset($_POST["lUname"]) ? $_POST["lUname"] : '';
$lPword = isset($_POST["lPword"]) ? $_POST["lPword"] : '';
$lEmail = isset($_POST["lEmail"]) ? $_POST["lEmail"] : '';
$lNewUn = isset($_POST["lNewUn"]) ? $_POST["lNewUn"] : '';
$lNewEm = isset($_POST["lNewEm"]) ? $_POST["lNewEm"] : '';
$lLang = isset($_POST["lLang"]) ? $_POST["lLang"] : $set['language'];
$cookie = empty($_POST['cookie']) ? '0' : '1';

if (isset($_POST["exereg"])) { //process registration
	do {
		if (!$xCode OR $xCode > $nowTS OR $xCode < $nowTS-300) { $msg = $ax['log_time_out']; break; }
		if (!$lUname) { $msg = $ax['log_no_un']; break; }
		if (!$lEmail) { $msg = $ax['log_no_em']; break; }
		if (!preg_match("/^[\w\s\._-]{2,}$/u", $lUname)) { $msg = $ax['log_un_invalid']; break; }
		if (!preg_match($rxEmail,$lEmail)) { $msg = $ax['log_em_invalid']; break; }
		$stH = stPrep("SELECT `name` FROM `users` WHERE `name` = ? AND `status` >= 0");
		stExec($stH,array($lUname));
		if ($stH->fetchAll()) { $msg = $ax['log_un_exists']; break; } //un already exists
		$stH = stPrep("SELECT `email` FROM `users` WHERE `email` = ? AND `status` >= 0");
		stExec($stH,array($lEmail));
		if ($stH->fetchAll()) { $msg = $ax['log_em_exists']; break; } //em already exists
		$newPw = substr(md5($lUname.microtime()), 0, 8);
		$stH = stPrep("INSERT INTO `users` (`name`,`password`,`email`,`groupID`,`language`) VALUES (?, ?, ?, ?, ?)");
		stExec($stH,array($lUname,md5($newPw),$lEmail,$set['selfRegGrp'],$lLang));
		$stH = null;
		$msgText = "{$emlHeader}<p>{$ax['log_pw_msg']}: {$set['calendarTitle']}.</p>\n";
		$msgText .= "<p>{$ax['log_log_in']}:<br>{$ax['log_un']}: <span class='bold'>{$lUname}</span> {$ax['or']} {$ax['log_em']}: <span class='bold'>{$lEmail}</span></p>\n";
		$msgText .= "<p>{$ax['log_pw']}: <span class='bold'>{$newPw}</span></p>\n{$emlTrailer}";
		$subject = str_replace('%%',$set['calendarTitle'],$ax['log_pw_subject']);
		sendMail($subject, $msgText, $lEmail); //send email
		unset($_POST["exereg"]); //go to login
		$lUn_Em = $lUname; //save for login
		$msg = $ax['log_registered'];
		if ($set['selfRegNot']) {
			notifyReg($lUname,$lEmail);
		}
	} while (false);
}

if (isset($_POST["exechg"])) { //process changes
	$lNewPw = isset($_POST["lNewPw"]) ? trim($_POST["lNewPw"]) : '';
	do {
		if (!$xCode OR $xCode > $nowTS OR $xCode < $nowTS-300) { $msg = $ax['log_time_out']; break; }
		if (!$lUn_Em) { $msg = $ax['log_no_un_em']; break; }
		if (!$lPword) { $msg = $ax['log_no_pw']; break; }
		$md5Pw = md5($lPword);
		$stH = stPrep("SELECT `ID`,`name`,`email`,`language` FROM `users` WHERE (`name` = ? OR `email` = ?) AND (`password` = ? OR `tPassword` = ?) AND `status` >= 0");
		stExec($stH,array($lUn_Em,$lUn_Em,$md5Pw,$md5Pw));
		$row = $stH->fetch(PDO::FETCH_NUM); //fetch user details
		$stH = null;
		if (!$row) { $msg = $ax['log_un_em_pw_invalid']; break; }
		list($ID,$name,$email,$language) = $row;
		if (!$lNewUn and !$lNewEm and !$lNewPw and $lLang == $language) { $msg = $ax['log_no_new_data']; break; }

		if ($lNewUn) {
			if (!preg_match("/^(\w|-|.){2,}$/", $lNewUn)) { $msg = $ax['log_invalid_new_un']; break; }
			$stH = stPrep("SELECT `name` FROM `users` WHERE `name` = ? AND `status` >= 0");
			stExec($stH,array($lNewUn));
			if ($stH->fetchAll()) { $msg = $ax['log_new_un_exists']; break; } //un already exists
			$name = $lNewUn;
		}
		if ($lNewEm) {
			if (!preg_match($rxEmail,$lNewEm)) { $msg = $ax['log_invalid_new_em']; break; }
			$stH = stPrep("SELECT `email` FROM `users` WHERE `email` = ? AND `status` >= 0");
			stExec($stH,array($lNewEm));
			if ($stH->fetchAll()) { $msg = $ax['log_new_em_exists']; break; } //em already exists
			$email = $lNewEm;
		}
		if ($lNewPw) {
			$md5Pw = md5($lNewPw);
		}
		if ($lLang) {
			$language = $lLang;
		}
		$stH = stPrep("UPDATE `users` SET `name` = ?,`password` = ?,`email` = ?,`language` = ? WHERE `ID` = ?");
		stExec($stH,array($name,$md5Pw,$email,$language,$ID));
		if ($lNewUn) { $lUn_Em = $lNewUn; }
		$msg = $ax['usr_updated'];
	} while (false);
}

if (isset($_POST["logIn"])) { //process log in
	do {
		if (!$lUn_Em) { $msg = $ax['log_no_un_em']; break; }
		if (!$lPword) { $msg = $ax['log_no_pw']; break; }
		if (!$xCode OR $xCode > $nowTS OR $xCode < $nowTS-300) { $msg = $ax['log_time_out']; break; }
		$md5Pw = md5($lPword);
		$stH = stPrep("SELECT u.`ID`,u.`password`,u.`tPassword`,u.`language`,g.`privs` FROM `users` AS u INNER JOIN `groups` AS g ON g.`ID` = u.`groupID` WHERE (u.`name` = ? OR `email` = ?) AND (`password` = ? OR `tPassword` = ?) AND u.`status` >= 0");
		stExec($stH,array($lUn_Em,$lUn_Em,$md5Pw,$md5Pw));
		$row = $stH->fetch(PDO::FETCH_ASSOC); //fetch user details
		$stH = null;
		if (!$row) { $msg = $ax['log_un_em_pw_invalid']; break;}
		if ($row['privs'] < 1) { $msg = $ax['log_no_rights']; break; }
		if ($row['tPassword']) { //temp password set
			$stH = stPrep("UPDATE `users` SET `password` = ?,`tPassword` = ? WHERE `ID` = ?");
			stExec($stH,array($md5Pw,'',$row['ID']));
		}
		echo "<script>index({userID:{$row['ID']},cP:0,bake:{$cookie}});</script>\n"; //goto default page
	} while (false);
}

if (isset($_POST["spw"])) { //send password by email
	do {
		if (!$lUn_Em) { $msg = $ax['log_no_un_em']; break; }
		$stH = stPrep("SELECT `name`,`email` FROM `users` WHERE (`name` = ? OR `email` = ?) AND `status` >= 0");
		stExec($stH,array($lUn_Em,$lUn_Em));
		$row = $stH->fetch(PDO::FETCH_ASSOC); //fetch user details
		$stH = null;
		if (!$row) { $msg = $ax['log_un_em_invalid']; break; }
		$sendto = $row['email'];
		$uname = $row['name'];
		$newPw = substr(md5($lUn_Em.microtime()),0,8);
		$cryptpw = md5($newPw);
		$stH = stPrep("UPDATE `users` SET `tPassword` = ? WHERE `name` = ? OR `email` = ?");
		stExec($stH,array(md5($newPw),$lUn_Em,$lUn_Em));
		$msgText = "{$emlHeader}<p>{$ax['log_pw_msg']}: {$set['calendarTitle']}.</p>\n";
		$msgText .= "<p>{$ax['log_log_in']}:<br>{$ax['log_un']}: <span class='bold'>{$uname}</span> {$ax['or']} {$ax['log_em']}: <span class='bold'>{$sendto}</span></p>\n";
		$msgText .= "<p>{$ax['log_pw']}: <span class='bold'>{$newPw}</span></p>\n{$emlTrailer}";
		$subject = str_replace('%%',$set['calendarTitle'],$ax['log_npw_subject']);
		sendMail($subject, $msgText, $sendto); //send email
		$msg = $ax['log_npw_sent'];
	} while (false);
}
echo '<p class="error">'.$msg."</p><br>\n";

echo "<div class='scrollBoxAd'>\n<div class='centerBox'>\n";
echo "<fieldset>\n";
if (isset($_POST["reg"]) or isset($_POST["exereg"])) { //register
	if (!$lUname and $lUn_Em and !strstr($lUn_Em, '@')) { $lUname = $lUn_Em; }
	echo "<legend>{$ax['log_register']}</legend><br>
		<form action='index.php' method='post'>
		<input type='hidden' name='xP' value=20>
		<input type='hidden' name='lcI' value='{$lcI}'>
		<input type='hidden' name='xCode' value='{$nowTS}'>
		<input type='hidden' name='lUn_Em' value='{$lUn_Em}'>
		{$ax['log_un']}<br><input tabindex='1' type='text' name='lUname' id='uname' size='50' value='{$lUname}'><br><br>
		{$ax['log_em']}<br><input tabindex='2' type='text' name='lEmail' size='50' value='{$lEmail}'><br><br>
		{$ax['log_ui_language']}&nbsp;&nbsp;
		<select name='lLang'>\n";
	$files = scandir("lang/");
	foreach ($files as $file) {
		if (substr($file,0,3) == "ui-") {
			$lang = strtolower(substr($file,3,-4));
			echo "<option value=\"{$lang}\"".(strtolower($lLang) == $lang ? ' selected' : '').'>'.ucfirst($lang)."</option>\n";
		}
	}
	echo "</select><br><br>
		<input class='floatR button' type='submit' name='exereg' value=\"{$ax['log_register']}\">
		<input type='submit' name='back' value=\"{$ax['back']}\">
		</form>\n";
} elseif (isset($_POST["chg"]) or isset($_POST["exechg"])) { //change my data
	if ($lUn_Em and $lPword) { 
		$md5Pw = md5($lPword);
		$stH = stPrep("SELECT `language` FROM `users` WHERE (`name` = ? OR `email` = ?) AND (`password` = ? OR `tPassword` = ?)");
		stExec($stH,array($lUn_Em,$lUn_Em,$md5Pw,$md5Pw));
		$row = $stH->fetch(PDO::FETCH_ASSOC); //fetch user details
		$stH = null;
		if ($row) { 
			$lLang = $row['language'];
		}
	}
	echo "<legend>{$ax['log_change_my_data']}</legend><br>
		<form action='index.php' method='post'>
		<input type='hidden' name='xP' value=20>
		<input type='hidden' name='lcI' value='{$lcI}'>
		<input type='hidden' name='xCode' value='{$nowTS}'>
		{$ax['log_un_or_em']}<br><input tabindex='1' type='text' name='lUn_Em' id='uname' size='50' value='{$lUn_Em}'><br><br>
		{$ax['log_pw']}<br><input tabindex='2' type='password' name='lPword' size='50'><br><br>
		{$ax['log_ui_language']}&nbsp;&nbsp;
		<select name='lLang'>\n";
	$files = scandir("lang/");
	foreach ($files as $file) {
		if (substr($file, 0, 3) == "ui-") {
			$lang = strtolower(substr($file,3,-4));
			echo "<option value=\"{$lang}\"".(strtolower($lLang) == $lang ? ' selected' : '').'>'.ucfirst($lang)."</option>\n";
		}
	}
	echo "</select><br><br>
		{$ax['log_new_un']}<sup>*</sup><br><input tabindex='3' type='text' name='lNewUn' size='50' value='{$lNewUn}'><br><br>
		{$ax['log_new_em']}<sup>*</sup><br><input tabindex='4' type='text' name='lNewEm' size='50' value='{$lNewEm}'><br><br>
		{$ax['log_new_pw']}<sup>*</sup><br><input tabindex='5' type='password' name='lNewPw' size='50'><br>
		<sup>*</sup><span class='fontS'> {$ax['log_if_changing']}</span><br><br>
		<input class='floatR button' type='submit' name='exechg' value='{$ax['log_change']}'>
		<input type='submit' name='back' value='{$ax['back']}'>
		</form>\n";
} else { //log in
	echo "<legend>{$ax['log_log_in']}</legend><br>
		<form action='index.php' method='post'>
		<input type='hidden' name='xP' value=20>
		<input type='hidden' name='lcI' value='{$lcI}'>
		<input type='hidden' name='xCode' value='{$nowTS}'>
		{$ax['log_un_or_em']}<br><input tabindex='1' type='text' name='lUn_Em' id='uname' size='50' value='{$lUn_Em}'><br><br>
		{$ax['log_pw']}<br><input tabindex='2' type='password' name='lPword' size='20'><br><br><br>
		<input type='submit' name='logIn' value=\"{$ax['log_log_in']}\">
		<span class='floatR'><input type='checkbox' id='cookie' name='cookie' value='1' ".(isset($_COOKIE['LCALuid']) ? " checked" : '')."><label for='cookie'> {$ax['log_remember_me']}</label></span>
		<br><br><hr>
		<input class='floatL' type='submit' name='chg' value=\"{$ax['log_change_my_data']}\">
		<input class='floatR' type='submit' name='spw' value=\"{$ax['log_send_new_pw']}\">\n";
	if ($set['selfReg']) { echo "<input class='center' type='submit' name='reg' value=\"{$ax['log_register']}\">\n"; }
	echo "</form>\n";
}
echo "</fieldset>\n</div>\n</div>\n";
echo '<script>$I("uname").focus();</script>'."\n";
?>